Index: plugins/blocks/quickmail/config_form.php
===================================================================
RCS file: plugins/blocks/quickmail/config_form.php
diff -N plugins/blocks/quickmail/config_form.php
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ plugins/blocks/quickmail/config_form.php	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,51 @@
+<?php // $Id: config_form.php,v 2.5 2008/02/15 09:53:43 pcali1 Exp $
+
+/**
+ *   Author: Philip Cali
+ *   Date: 2/15/08
+ *   Louisiana State University
+ *   
+ *   Moodle form for configuring the Quickmail block
+ */
+
+require_once($CFG->libdir . '/formslib.php');
+
+define('STUDENT_SELECT', 'allowstudents');
+define('ROLE_SELECT', 'roleselection');
+define('COURSE_ID', 'id');
+define('INSTANCE_ID', 'instanceid');
+
+class config_form extends moodleform {
+    
+    function definition() {
+        global $CFG, $USER;
+
+        $form=&$this->_form;
+
+        /*original select*/
+        $student_select = array(0 => get_string('no'), 1=>get_string('yes'));
+        $form->addElement('select', STUDENT_SELECT, get_string('allowstudents', 'block_quickmail'), $student_select);
+
+
+        $form->addElement('static', 'static_role', get_string('select_roles', 'block_quickmail'), '');
+        
+        $roles = get_records('role');
+        $role_select = array();
+        foreach ($roles as $role) {
+            $form->addElement('checkbox', ROLE_SELECT. ':'. $role->shortname, '', $role->name);
+        }
+
+        //hidden fields needed to process the form
+        $form->addElement('hidden', COURSE_ID, '');
+        $form->addElement('hidden', INSTANCE_ID, '');
+
+        $buttonarray = array();
+        $buttonarray[] = &$form->createElement('submit', 'submitbutton', 
+                                 get_string('submit', 'block_quickmail'));
+        $buttonarray[] = &$form->createElement('cancel');
+        $form->addGroup($buttonarray, 'buttonarr', '', array(' '), false);
+        $form->closeHeaderBefore('buttonarr');
+    }
+}
+
+?>
Index: plugins/blocks/quickmail/selection.js
===================================================================
RCS file: plugins/blocks/quickmail/selection.js
diff -N plugins/blocks/quickmail/selection.js
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ plugins/blocks/quickmail/selection.js	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,275 @@
+/**
+ * selection.js - Defines functions used by email.html in quickmail package
+ *
+ * Edited by: Philip Cali
+ * 2008/02/15 15:03:00
+ *
+ * @author: Bibek Bhattarai and Wen Hao Chuang
+ * 2007/03/29 09:00:00 
+ * @package quickmailv2
+ **/
+
+//Global variables used for pointing to members and mailto selection list
+var selectedList;
+var availableList;
+var availablegroups;
+var availableRoles;
+var oldGroupList;
+var newList;
+var selectedGroupidList;
+
+/** This function initializes selectedlist and availablelist with members and mailto selection lists respectively.
+  * This function is called everytime html form is reloaded 
+  **/
+function createListObjects(){
+    //availableRoles points to the role filter list, that holds a list of "filters"
+    availableRoles = document.getElementById("roles");
+    //availablegroups points to the groups list, that holds a list of groups/sections in a course
+    availablegroups = document.getElementById("groups");
+	//availablelist points to members list, that holds list of users (Teachers and Students) present in the class
+	availableList = document.getElementById("members");
+	//Selectedlist points to mailto list, that holds list of users (Teachers and Students) to which email has to be sent
+	selectedList = document.getElementById("mail_to");
+
+    oldGroupList = singlePassPreviousList(availablegroups);
+}
+
+function singlePassPreviousList(passedList) {
+    selectedGroupidList = new Array();
+    list = new Array(passedList.options.length);
+    for (var i=0; i< passedList.options.length; i++) {
+        list[i] = passedList.options[i].selected;
+        if (list[i]) {
+            var val = passedList.options[i].value;
+            var vararr = val.split(" ");
+            selectedGroupidList.push(vararr[0]);
+        }
+    }
+    
+    selectedGroupidList.push("");
+    return list;
+}
+
+//apply filter to select_users
+function special_select_users() {
+      if (!availableRoles){
+        createListObjects();
+      }
+      select_users(availablegroups, availableRoles.options[availableRoles.selectedIndex].value);
+}
+
+//abstract select users
+function select_users(list, filter) {
+    // select all the users that belong to that group
+    if (list == null) {
+        return;
+    }    
+
+    newList = singlePassPreviousList(list);
+    differentIndexes = oldGroupList.diff(newList);    
+    
+
+    if (differentIndexes != null) {
+      for (var index =0; index < differentIndexes.length; index++) {
+        if (list.options[differentIndexes[index]]){
+            var selected = list.options[differentIndexes[index]].selected;
+            var interestarr = list.options[differentIndexes[index]].value.split(" ");
+            var interest = interestarr[0];
+        }
+        var role_filter = (filter==null) ? "none" : filter;
+
+        if (selected) {
+            select_list(availableList, interest, role_filter);
+            select_list(selectedList, interest, role_filter);
+        } else {
+            deselect_list(availableList, interest, role_filter);
+            deselect_list(selectedList, interest, role_filter);
+        }
+
+      }
+    }
+
+    oldGroupList = newList;
+}
+
+function deselect_list(list, interest, filter) {
+    for (var j=list.length-1; j>=0; j--) {
+        var val = list.options[j].value;
+        var vararr = val.split(" ");
+        var groups = vararr[2].split(",");
+        var roles = vararr[3].split(",");
+        if (groups.contains(interest)) {
+            if (groups.length ==2) {
+                list.options[j].selected = false;
+            } else if (!checkAllGroups(groups, selectedGroupidList)){
+                list.options[j].selected = false;
+            } else if (filter != "none" && !roles.contains(filter)) {
+                list.options[j].selected = false;
+            }
+        }
+    }
+}
+
+function checkAllGroups(list1, list2) {
+    for (var i =0; i< list1.length; i++) {
+        if (list2.contains(list1[i])) {
+            return true;
+        }
+    }
+    return false;
+}
+
+function select_list(list, interest, filter) {
+    for (var j=list.length-1; j>=0; j--) {
+        var val = list.options[j].value;
+        var vararr = val.split(" ");
+        var groups = vararr[2].split(",");
+        var roles = vararr[3].split(",");
+        if (groups.contains(interest)) {
+            if (filter == "none" || roles.contains(filter)) {
+                list.options[j].selected = true;
+            }    
+        }
+    }
+}
+
+/** This function is used to remove user from selected list and add it back to available list */
+function remove_user(){
+	//for all items in selected list
+	for(var i=selectedList.length-1; i>=0; i--){
+		//if selected, append the user to available list. 
+		//Append will automatically remove it from selected list
+		if(selectedList.options[i].selected == true){
+		    availableList.appendChild(selectedList.options[i]);
+		}		
+	}
+	//call selectnone function to remove selection/highlight after move
+	selectNone(selectedList, availableList, availablegroups);	
+}
+
+/** This function is used to add user to selectedlist and remove it from available list */
+function add_user(){
+	//for all items in available list
+	for(var i=availableList.length-1; i>=0; i--){
+		//if selected, append the user to selected list.
+		//Append will automatically remove it from available list
+		if(availableList.options[i].selected == true){
+			selectedList.appendChild(availableList.options[i]);
+		}
+	}
+
+	//call selectnone function to remove selection/hightlight after move
+	selectNone(selectedList, availableList, availablegroups);	
+}
+
+/** This function is used to remove all users from selectionlist and add them to available list */
+function removeAll(){
+	var len = selectedList.length-1;
+	//Select all users in selected list and append them to available list
+	for(i=len; i>=0; i--){
+		availableList.appendChild(selectedList.options[i]);	
+	}
+	//De-select all users after move
+	selectNone(selectedList, availableList, availablegroups);	
+}
+
+/** This function is used to add all users from availablelist to selectionlist*/
+function addAll(){
+	var len = availableList.length - 1;
+	//Select all users from availablelist and append them to selectedlist
+	for(i=len; i>=0; i--){
+		selectedList.appendChild(availableList.options[i]);
+	}
+	//De-select all users after move
+	selectNone(selectedList, availableList, availablegroups);
+}
+
+/** This function is used to deselect users in availablelist, selectedlist after move */
+function selectNone(list1, list2, list3){
+	//Set all elements on list1 to selected false
+	for(var i=list1.length-1; i>=0 ; i--){
+		list1.options[i].selected = false;		
+	}
+	//Set all elements on list2 to selected false
+	for(var i=list2.length-1; i>=0; i--){
+		list2.options[i].selected = false;
+	}
+    //Set all elements on list3 to selected false
+    for (var i=list3.length-1; i>=0; i--){
+        list3.options[i].selected = false;
+    }
+}
+
+/** This function is used to construct the list of user to whom email has to be sent */
+function updateList(){
+	var ids = '';
+	// add user id of all elements in seleted list to string email as comma seperated value
+	for(var i=selectedList.length-1; i>=0 ; i--){
+		var val = selectedList.options[i].value;
+		var valarr = val.split(" ");
+		val = valarr[0];
+		ids = ids+val;
+		//do not add "," after last element
+		if(i!=0){
+			ids = ids+',';		
+		}
+	}
+	//set hidden input value mailuser as email
+	document.getElementById("mailuser").value = ids ;	
+}
+
+/** This function is used to construct the list of user to whom email has to be sent.
+	This function builds list of emails to be sent through external client*/
+function mail_to_ext_client(){
+	var emails = '';
+	// add user id of all elements in seleted list to string email as comma seperated value
+	for(var i=selectedList.length-1; i>=0 ; i--){
+		var val = selectedList.options[i].value;
+		var valarr = val.split(" ");
+		val = valarr[1];
+		emails = emails+val;
+		//do not add "," after last element
+		if(i!=0){
+			emails = emails+',';		
+		}
+	}
+	from_email = document.getElementById("fromemail").value;
+	//Redirects to external client with list of emails as bcc recievers
+	location.href='mailto:'+from_email+'?bcc='+emails;
+}
+
+
+
+Array.prototype.contains = function(element) {
+    if (element == null || element == '') {
+        return false;
+    }
+
+    for (var i =0; i< this.length; i++) {
+        if (this[i] == element) {
+            return true;
+        }
+    }
+    return false;
+}
+
+Array.prototype.diff = function(secondArray) {
+    if (secondArray == null) {
+        return null;
+    }
+
+    if (this.length != secondArray.length) {
+        return null;
+    }
+
+    diffList = new Array();
+
+    for (var i=0; i < secondArray.length ; i++) {
+        if (this[i] != secondArray[i]) {
+            diffList.push(i);
+        }
+    }
+
+    return diffList;
+}
+
Index: plugins/blocks/quickmail/quickmail_config.php
===================================================================
RCS file: plugins/blocks/quickmail/quickmail_config.php
diff -N plugins/blocks/quickmail/quickmail_config.php
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ plugins/blocks/quickmail/quickmail_config.php	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,108 @@
+<?php // $Id: quickmail_config.php,v 2.5 2008/02/15 09:53:43 pcali1 Exp $
+
+/**
+ *   Author: Philip Cali
+ *   Date: 2/15/2008
+ *   Louisiana State University
+ *
+ *   Moodle form for the quickmail config
+ */
+
+require_once('../../config.php');
+require_once("$CFG->dirroot/blocks/moodleblock.class.php");
+require_once('config_form.php');
+require_once($CFG->libdir . '/accesslib.php');
+require_once('block_quickmail.php');
+
+require_login();
+
+// get the course id, and block instanceid
+$id = required_param('id', PARAM_INT);
+$instanceid = optional_param('instanceid', 0, PARAM_INT);
+
+$quickmail = new block_quickmail();
+$instance = new stdClass;
+
+
+if (!$course = get_record('course', 'id', $id)) {
+    error('Could not load course!');
+}
+
+$pinned = false;
+
+//determine whether this instance is a pinned block, or regular instance
+ if ($instanceid && $quickmailblock = get_record('block', 'name', 'quickmail')) {
+    $instance = get_record('block_instance', 'id', $instanceid, 'blockid', $quickmailblock->id);
+    if (!$instance){
+        $pinned = true;
+        $instance = get_record('block_pinned', 'id', $instanceid, 'blockid', $quickmailblock->id);
+    }
+ }
+
+$quickmail->_load_instance($instance);
+$quickmail->load_defaults();
+
+//can user alter quickmail config?
+if (!$quickmail->check_permission('block/quickmail:canconfig', CONTEXT_COURSE, $course)) {
+    error(get_string('no_permission', 'block_quickmail'));
+}
+
+$form = new config_form();
+
+if ($form->is_cancelled()) {
+    redirect("$CFG->wwwroot/course/view.php?id=$course->id");
+}
+
+if ($data = $form->get_data()) {
+    $config = new stdClass;
+    $roleselection = array();
+
+    foreach ($data as $key => $value) {
+        $keyarr = explode(':', $key);
+        if ($keyarr[0] == ROLE_SELECT) {
+            $role = get_record('role', 'shortname', $keyarr[1]);
+            $roleselection[$role->shortname] = $role->name;
+        }
+    }
+
+    $config->allowstudents = $data->allowstudents;
+    $config->roleselection = $roleselection;
+    $config->groupmode = $course->groupmode;
+   
+    //Save into the instance without having to create a special table in the database or anything (using moodle's tables)
+    $quickmail->instance_config_save($config, $pinned);
+
+    //Redirect back to course
+    redirect("$CFG->wwwroot/course/view.php?id=$course->id");
+
+} else if (!$form->is_submitted()) {
+    //Load the form with the correct values
+
+   $form_data = array(
+        STUDENT_SELECT => $quickmail->config->allowstudents,
+        COURSE_ID => $course->id,
+        INSTANCE_ID => $quickmail->instance->id
+    );
+   
+   $quickmail_roles = $quickmail->grab_roles();
+   foreach ($quickmail_roles as $role_shortname => $role_name) {
+       $form_data[ROLE_SELECT.':'.$role_shortname] = true;
+   }    
+
+   $form->set_data($form_data);
+}
+
+$strquickmail = get_string('blockname', 'block_quickmail');
+
+$navigation = array(
+    array('name' => $course->shortname, 'link'=>"$CFG->wwwroot/course/view.php?id=$course->id", 'type'=>'title'),
+    array('name' => $strquickmail, 'link'=>'', 'type'=>'title')
+    );
+
+print_header_simple($strquickmail, '', build_navigation($navigation));
+
+print_heading('Configuring a '. $strquickmail .' block');
+$form->display();
+print_footer();
+
+?>
Index: plugins/blocks/quickmail/attachment.js
===================================================================
RCS file: plugins/blocks/quickmail/attachment.js
diff -N plugins/blocks/quickmail/attachment.js
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ plugins/blocks/quickmail/attachment.js	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,85 @@
+/*
+    Author: Philip Cali
+    Date: 2/15/2008
+    Louisiana State University
+
+    java script for applying multiple attachments
+*/
+
+//place holder for all attachment input tags
+var attachArray = new Array("attach_1");
+
+//function adds a remove link, and builds a new attachment field
+function create_new_attachment(input_id) {
+    //main table is the display table
+    main_table = document.getElementById("maintable");
+
+    //loaded attachment: an attachment field that has been loaded
+    input_tag = document.getElementById(input_id);
+    //table row associated with attachment
+    table_row = document.getElementById(input_id+"row");
+
+    var new_cell = table_row.insertCell(table_row.cells.length);
+    //create the remove link
+    new_cell.innerHTML = "<a onclick=\"remove_attachment('"+ input_id +"')\" href=\"javascript:void\">Remove</a>";
+
+    //time to create the new attachment field
+    var new_row = main_table.insertRow(main_table.findRow("attach") +1 );
+    var new_id = input_id.split("_");
+
+    var id_number = parseInt(new_id[1]) + 1;
+    new_row.id = new_id[0] + "_" + id_number + "row";
+
+    new_row.insertCell(0);
+    var input_cell = new_row.insertCell(1);
+    input_cell.colSpan = "2";
+
+    var new_input_id = new_id[0] + "_" + id_number;
+    input_cell.innerHTML = "<input id=\""+ new_input_id+ "\" name=\""+new_input_id+"\" type=\"file\" size=\"45\" onchange=\"javascript:create_new_attachment('"+ new_input_id +"')\"/>";
+    
+    //keep track of our attachments
+    attachArray.push(new_input_id); 
+    
+    //store in hidden field to process in email.php
+    document.getElementById("attachids").value=attachArray.toString();
+}
+
+//this is executed when the remove link is clicked
+function remove_attachment(input_id) {
+   //get the main display table
+   main_table = document.getElementById("maintable");
+   
+   //get table row associated with the remove link
+   table_row = document.getElementById(input_id + "row");
+    
+   //remove it
+   main_table.deleteRow(table_row.rowIndex);
+
+   //keep track
+   attachArray.remove(input_id);
+   
+   document.getElementById("attachids").value = attachArray.toString();
+}
+
+
+/** Function added to the table class that returns the index 
+ * matching the id of the row in question
+ */
+HTMLTableElement.prototype.findRow = function(id) {
+    for (i=this.rows.length-1; i>=0; i--) {
+        rowid = this.rows[i].id;
+        
+        if (rowid && id.search(rowid)) {
+            return i;
+        }
+    }
+    return -1;
+}
+
+//loaded prototype for array index removal
+Array.prototype.remove = function(s) {
+    for (i=0;i<this.length;i++) {
+        if (s==this[i]) this.splice(i, 1);
+    }
+}
+
